#=====================================================================
#   Sendmail.pm : Send a mail by sendmail command (MIME support)
#
#   Copyright(c) 2001, Nobuchika Oishi (BSC CONSULTING).
#
#   e-mail : bigstone@my.email.ne.jp
#   support: http://www.din.or.jp/~bigstone/cgilab/index.html
#
#   THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND
#   ANY EXPRESS OR IMPLIED WARRANTIES ARE DISCLAIMED.
#
#   ver 1.0.1 : updated last on 2001/10/29
#
#---------------------------------------------------------------------
#   [gp]
#
#   ȉ̊e̎wJISR[hϊMIMEGR[hIɍsB
#   sendmailR}h -i IvVw肵Ăꍇ́ADotskipw
#   ōssIh̏C֎~邱ƁBrequest()p^̏ڍׂɂ
#    MIME.pm (encode_message)̐QƁB
#
#   use Sendmail;
#
#   my $mail = Sendmail->new("/usr/sbin/sendmail -t -oi");
#
#   (1) łPȌ`
#
#   $mail->request(
#       From    => $from,
#       To      => $to,
#       Subject => $subject,
#       Dotskip => 1,
#       Content => [
#           { message => $plain_message, },
#       ]
#   );
#
#   (2) {}`p[gbZ[W(multipart/alternative)
#
#   $mail->request(
#       From    => $from,
#       To      => $to,
#       Subject => $subject,
#       Dotskip => 1,
#       Content => [
#           { type    => 'text/plain',
#             message => $plain_message,
#           },
#           { type    => 'text/html',
#             message => $html_message,
#           },
#       ]
#   );
#
#   (3) Ytt@Cwǉꍇ
#
#   $mail->request(
#       From    => $from,
#       To      => $to,
#       Subject => $subject,
#       Dotskip => 1,
#       Content => [
#           { type    => "text/plain",
#             message => $plain_message,
#           },
#           { type    => "text/html",
#             message => $html_message,
#           },
#       ],
#       Attach  => {
#           file_name1 => "/file/path/name1",
#           file_name2 => "/file/path/name2",
#       }
#   );
#
#=====================================================================
package Sendmail;

use strict;
use integer;
use Symbol;
use MIME;
use vars qw($VERSION $MAX_RECIPIENTS);

#---------------------------------------------------------------------
$MAX_RECIPIENTS = 100;
#---------------------------------------------------------------------

$VERSION = '1.0.1';

sub new {
    my $class = shift;
    my $path  = shift || return undef;
    my $self  = Symbol::gensym();
    open($self, "| $path") or return undef;
    return bless $self, ref $class || $class;
}

sub request {
    my $self = shift;
    my(%parm, $k, $v);
    while (($k, $v) = splice(@_, 0, 2)){
        $parm{lc($k)} = $v;
    }
    my @recipient = ();
    foreach ('to', 'cc', 'bcc'){
        next unless $parm{$_};
        if(ref $parm{$_}){
            push(@recipient, @{$parm{$_}});
        } else {
            push(@recipient, split(/ *[,;] */, $parm{$_}));
        }
    }
    if(@recipient == 0 || @recipient > $MAX_RECIPIENTS){
        return undef;
    }
    return undef unless $parm{from};
    if(defined $parm{attach}){
        if(scalar keys(%{$parm{attach}}) > 0){
            foreach (values %{$parm{attach}}){
                return undef unless -r $_;
            }
        } else {
            delete $parm{attach};
        }
    }
    return undef unless($parm{content} || $parm{attach});
    my $mime = MIME->new(sendmail => $self);
    my $stat = $mime->encode_message(\%parm);
    $self->close();
    return $stat;
}

sub close {
    my $self = shift;
    close($self) if defined fileno($self);
}

sub DESTROY {
    shift->close();
}

1;

__END__
